<template>
  <div class="page">
    <div
      class="back-link"
      @click="$router.push({ name: 'Resources' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Ressources
      </span>
    </div>
    <b-overlay
      v-if="loading"
      id="overlay-background"
      :show="loading"
      :variant="'white'"
      :opacity="0.7"
      :blur="'2px'"
      rounded="sm"
      style="min-height: 30em;"
    >
    </b-overlay>
    <b-container v-else fluid>
      <b-row>
        <b-col
          cols="8"
          class="detail-forms"
          style="overflow-x: hidden;"
        >
          <ValidationObserver v-slot="{ handleSubmit }">
            <form>
              <h3 class="line-header">
                <img
                  src="@/assets/icons/form_description_file.svg"
                  alt="Icône fichier"
                /> Fiche ressource
              </h3>
              <div class="form-row">
                <div class="form-group col-12">
                  <label class="required">Titre</label>
                  <ValidationProvider rules="required" v-slot="{ classes, errors }">
                    <div class="control" :class="classes">
                      <input
                        v-model="form.titre"
                        class="form-control"
                        :class="{}"
                        type="text"
                        placeholder="Titre"
                      >
                      <span class="form-errors">{{ errors[0] }}</span>
                    </div>
                  </ValidationProvider>
                </div>
              </div>
              <div class="form-row">
                <div class="form-group col-12">
                  <label>Description de la donnée</label>
                  <textarea
                    v-model="form.description"
                    class="form-control"
                  />
                </div>
              </div>
              <h3 class="line-header">
                <img
                  src="@/assets/icons/company.svg"
                  alt="Icône organisation"
                /> Organisation
              </h3>
              <div class="form-row">
                <div class="form-group col-12">
                  <label style="margin-top: 1em;">Nom de l'organisation</label>
                  <p>Sélectionner une organisation dans la liste</p>
                  <!-- <ValidationProvider rules="required" v-slot="{ classes, errors }"> -->
                    <!-- <div class="control" :class="classes"> -->
                      <Multiselect
                        v-model="form.organisation"
                        :options="organisationsList"
                        track-by="id"
                        label="display_name"
                        selectLabel=""
                        selectedLabel=""
                        deselectLabel=""
                        :searchable="false"
                        placeholder="Nom de l'organisation"
                      />
                      <!-- <span class="form-errors">{{ errors[0] }}</span> -->
                    <!-- </div> -->
                  <!-- </ValidationProvider> -->
                </div>
              </div>
              <h3 class="line-header">
                <img
                  src="@/assets/icons/data_layers.svg"
                  alt="Icône calendrier"
                /> Jeux de données
              </h3>
              <b-row style="height: auto;">
                <b-col
                  cols="12"
                  class="resources-table"
                >
                  <CustomTable
                    v-if="datasetsTableItems.length > 0"
                    style="margin-left: -1em;"
                    :routeTo="'DatasetDetail'"
                    :fields="datasetsTableFields"
                    :items="datasetsTableItems"
                    :sortFunction="GET_DATASETS_LIST"
                    :selectable="false"
                    :allowDeletion="false"
                    @sorted="setTableSorted"
                    @loading="setTableLoader"
                  />
                </b-col>
              </b-row>
              <div class="form-footer">
                <b-button
                  variant="outline-secondary"
                  @click="$router.go(-1)"
                >
                  Annuler
                </b-button>
                <b-button
                  variant="primary"
                  style="float: right"
                  @click="handleSubmit(saveResource)"
                >
                  Enregistrer
                </b-button>
              </div>
            </form>
          </ValidationObserver>
        </b-col>
        <b-col
          class="detail-card"
        >
          <ResourceCard
            :resource="currentResource"
          />
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import  { mapState, mapActions } from 'vuex';

import ResourceCard from '@/components/Cards/ResourceCard.vue';
import CustomTable from '@/components/CustomTable.vue';
import Multiselect from 'vue-multiselect';

import resourcesAPI from '@/api/resourcesAPI.js';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: 'Ce champ est requis'
});
configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'ResourceDetail',

  components: {
    ResourceCard,
    CustomTable,
    Multiselect,
    ValidationObserver,
    ValidationProvider
  },

  data() {
    return {
      loading: false,
      thumbnail: null,
      form: {
        titre: null,
        description: null,
        organisation: null
      },
      datasetsTableFields: [
        {
          key: 'Nom',
          apiName: 'display_name',
          sortable: true,
          width: '',
          centered: false
        },
        {
          key: 'Type',
          sortable: false,
          width: '',
          centered: false
        },
        {
          key: 'Organisation',
          sortable: false,
          width: '30%',
          centered: false
        },
        {
          key: 'Date de création',
          sortable: false,
          width: '15%',
          centered: true
        },
        {
          key: 'Date de dernière révision',
          sortable: false,
          width: '20%',
          centered: true
        }
      ],
      tableSorted: {
        direction: null,
        field: null
      }
    };
  },

  computed: {
    ...mapState('resources', ['currentResource']),
    ...mapState('datasets', ['datasetsList']),
    ...mapState('organisations', ['organisationsList']),
    datasetsTableItems() {
      return this.currentResource.datasets.map(el => {
        return {
          id: el.dataset_id,
          'Nom': el.dataset.display_name,
          'Type': el.type.label,
          'Organisation': el.dataset.usergroup ? el.dataset.usergroup.display_name : '',
          'Date de création': new Date(el.dataset.creation_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"}),
          'Date de dernière révision': new Date(el.dataset.last_revision_date).toLocaleString('fr-FR', {year: "numeric", month: "long", day: "numeric"})
        }
      });
    }
  },

  created() {
    this.loading = true;
    this.GET_RESOURCE_DETAIL(this.$route.params.id).then(() => {
      this.loading = false;
      this.form.titre = this.currentResource.display_name;
      this.form.description = this.currentResource.description;
      this.form.organisation = this.currentResource.usergroup;
    });
    if (this.organisationsList.length === 0) {
      this.GET_ORGANISATIONS_LIST({
        direction: null,
        field: null
      });
    }
    if (this.datasetsList.length === 0) {
      this.GET_DATASETS_LIST({
        direction: null,
        field: null
      });
    }
  },

  methods: {
    ...mapActions('resources', ['GET_RESOURCE_DETAIL', 'GET_RESOURCES_LIST']),
    ...mapActions('datasets', ['GET_DATASETS_LIST']),
    ...mapActions('organisations', ['GET_ORGANISATIONS_LIST']),

    saveResource() {
      const data = {
        ...this.currentResource,
        titre: this.form.titre,
        description: this.form.description,
        usergroup: this.form.organisation.id
      };
      this.loading = true;
      resourcesAPI.updateResource(this.currentResource.id, data)
      .then(() => {
        this.GET_RESOURCE_DETAIL(this.currentResource.id);
        this.GET_RESOURCES_LIST({
          direction: null,
          field: null
        });
        this.loading = false;
      });
    },

    setTableLoader(e) {
      this.loading = e;
    },

    setTableSorted(e) {
      this.tableSorted = e;
    }
  }
}
</script>
